//
//  TSMirrorCameraView.swift
//  Girly
//
//  Created by 100Years on 2025/1/8.
//

class TSMirrorCameraView: TSBaseView {
    
    private var shwoWidth:CGFloat = k_ScreenWidth - 32
    var imageNamed:String = "mirror_round" {
        didSet{
            if let image = UIImage(named: imageNamed) {
                setShapeView(shapeView: cameraView)
            }
        }
    }
    
//    lazy var imageView: UIImageView = {
//        let imageView = UIImageView()
//        imageView.backgroundColor = .yellow
//        imageView.contentMode = .scaleAspectFit
//        return imageView
//    }()
    
    lazy var cameraManager: CameraManager = {
        let cameraManager = CameraManager()
        cameraManager.cameraDevice = CameraDevice.front
        cameraManager.cameraOutputQuality = .high
        cameraManager.showAccessPermissionPopupAutomatically = true
        return cameraManager
    }()
    
    
    lazy var cameraView: UIView = {
        let cameraView = UIView()
        cameraView.frame = CGRect(x: 0, y: 0, width: shwoWidth, height: shwoWidth)
        return cameraView
    }()
    
    lazy var notDeterminedView: UIView = {
        let notDeterminedView = UIView()

        return notDeterminedView
    }()
    
    
    override func creatUI() {
        
        contentView.addSubview(cameraView)
        cameraView.snp.makeConstraints { make in
            make.leading.equalTo(0)
            make.trailing.equalTo(0)
            make.top.equalTo(0)
            make.bottom.equalTo(0)
        }
        
//        contentView.addSubview(imageView)
//        imageView.snp.makeConstraints { make in
//            make.center.equalToSuperview()
//            make.width.equalTo(shwoWidth)
//            make.height.equalTo(shwoWidth)
//        }
        
        self.layoutIfNeeded()
        cameraManager.askUserForCameraPermission { [weak self]  permissionGranted in
            guard let self = self else { return }
            
            if permissionGranted {
            
                kDelayMainShort {
                    self.setShapeView(shapeView: self.cameraView)
                }
        
        self.addCameraToView()
                
            } else {
                if #available(iOS 10.0, *) {
                    UIApplication.shared.open(URL(string: UIApplication.openSettingsURLString)!)
                } else {
                    // Fallback on earlier versions
                }
            }
        }
        


    }
    
    func setShapeView(shapeView:UIView){
        if let image = UIImage(named: imageNamed) {
            shapeView.setImageMask(image: image)
        }
    }
    
    
    fileprivate func addCameraToView() {
        cameraManager.addPreviewLayerToView(cameraView)
        cameraManager.showErrorBlock = { [weak self] (erTitle: String, erMessage: String) -> Void in
            debugPrint(erMessage)
        }
        
    
    }
    
    
    func startCapture() {
//        cameraManager.resumeCaptureSession()

    }
    
    func endCapture() {
//        cameraManager.stopCaptureSession()
    }
}
